import Taro, {Component} from '@tarojs/taro'
import { View, Image, Text, Swiper, SwiperItem, ScrollView, Input, Icon } from '@tarojs/components'
import { connect } from '@tarojs/redux'
import { setUserInfo } from '@/actions/user'
import NavBar from '@/components/NavBar'
import LoginAuth from '@/components/LoginAuth'
import './index.scss'


@connect(({ user, nav }) => ({
  user, nav
}), (dispatch) => ({
  setUserInfo (data) {
    dispatch(setUserInfo(data || {}))
  },
}))
class Index extends Component {

  state = {
    showSearch: false,
    pageName: '首页',
    // banner数据
    banner: [
      {
        url: 'https://ss0.bdstatic.com/94oJfD_bAAcT8t7mm9GUKT-xh_/timg?image&quality=100&size=b4000_4000&sec=1586229157&di=6997346b65b0e2e2ff7a733ae9b5fcc5&src=http://a3.att.hudong.com/14/75/01300000164186121366756803686.jpg'
      },
      {
        url: 'https://ss0.bdstatic.com/94oJfD_bAAcT8t7mm9GUKT-xh_/timg?image&quality=100&size=b4000_4000&sec=1586229157&di=6997346b65b0e2e2ff7a733ae9b5fcc5&src=http://a3.att.hudong.com/14/75/01300000164186121366756803686.jpg'
      },
      {
        url: 'https://ss0.bdstatic.com/94oJfD_bAAcT8t7mm9GUKT-xh_/timg?image&quality=100&size=b4000_4000&sec=1586229157&di=6997346b65b0e2e2ff7a733ae9b5fcc5&src=http://a3.att.hudong.com/14/75/01300000164186121366756803686.jpg'
      }
    ],
    // 券数据
    scrollxData: [
      {
        type: 1,
        url: 'https://ss0.bdstatic.com/94oJfD_bAAcT8t7mm9GUKT-xh_/timg?image&quality=100&size=b4000_4000&sec=1586229157&di=6997346b65b0e2e2ff7a733ae9b5fcc5&src=http://a3.att.hudong.com/14/75/01300000164186121366756803686.jpg',
        name: '12元伊利纯牛奶兑换券',
        time: '2019.05.09-2019.09.09',
      },
      {
        type: 2,
        url: '',
        name: '12元伊利纯牛奶兑换券',
        time: '2019.05.09-2019.09.09',
      },
    ],
    // 门店数据
    storeList: [
      {
        img: 'http://hh-oss-picture.miyapay.com/box/e43fc1fd3ec446d985fef922388b4e00.png',
        name: '米雅便利店（北京1店）',
        time: '2019.05.09-2019.09.09',
        distance: '200m',
      },
      {
        img: 'http://hh-oss-picture.miyapay.com/box/e43fc1fd3ec446d985fef922388b4e00.png',
        name: '米雅便利店（北京1店）',
        time: '2019.05.09-2019.09.09',
        distance: '200m',
      },
      {
        img: 'http://hh-oss-picture.miyapay.com/box/e43fc1fd3ec446d985fef922388b4e00.png',
        name: '米雅便利店（北京1店）',
        time: '2019.05.09-2019.09.09',
        distance: '200m',
      },
      {
        img: 'http://hh-oss-picture.miyapay.com/box/e43fc1fd3ec446d985fef922388b4e00.png',
        name: '米雅便利店（北京1店）',
        time: '2019.05.09-2019.09.09',
        distance: '200m',
      },
      {
        img: 'http://hh-oss-picture.miyapay.com/box/e43fc1fd3ec446d985fef922388b4e00.png',
        name: '米雅便利店（北京1店）',
        time: '2019.05.09-2019.09.09',
        distance: '200m',
      },
      {
        img: 'http://hh-oss-picture.miyapay.com/box/e43fc1fd3ec446d985fef922388b4e00.png',
        name: '米雅便利店（北京1店）',
        time: '2019.05.09-2019.09.09',
        distance: '200m',
      },
      {
        img: 'http://hh-oss-picture.miyapay.com/box/e43fc1fd3ec446d985fef922388b4e00.png',
        name: '米雅便利店（北京1店）',
        time: '2019.05.09-2019.09.09',
        distance: '200m',
      },
      {
        img: 'http://hh-oss-picture.miyapay.com/box/e43fc1fd3ec446d985fef922388b4e00.png',
        name: '米雅便利店（北京1店）',
        time: '2019.05.09-2019.09.09',
        distance: '200m',
      }
    ]
  }
  componentWillReceiveProps (nextProps) {
    console.log(this.props, nextProps)
  }

  componentWillUnmount () { }
  componentDidMount() {
    this.handleLocation();
  }
  componentDidShow () { }

  componentDidHide () { }

  // 获取地址授权
  handleLocation() {
    // 可以通过 wx.getSetting 先查询一下用户是否授权了 "scope.record" 这个 scope
    Taro.getSetting({
      success:function(res){
        if (!res.authSetting['scope.userLocation']) {
          console.log("-------------不满足scope.userLocation权限----------");
          //申请授权
          Taro.authorize({
            scope: 'scope.userLocation',
            success() {},
            fail () {
              Taro.showModal({
                title: '是否授权当前位置',
                content: '需要获取您的地理位置，请确认授权，否则地图功能将无法使用',
                success: function (tip) {
                  if (tip.confirm) {
                      Taro.openSetting({
                        success: function (data) {
                          if (data.authSetting["scope.userLocation"] === true) {
                            Taro.showToast({
                              title: '授权成功',
                              icon: 'success',
                              duration: 1000
                            })
                          } else {
                            Taro.showToast({
                              title: '授权失败',
                              icon: 'success',
                              duration: 1000
                            })
                          }
                        }
                      })
                  }
                }
              })
            }
          })
        }
      }
    })
  }
  // 手动选择地址
  selectCity(){
    const {setUserInfo} = this.props
    // 可以通过 wx.getSetting 先查询一下用户是否授权了 "scope.record" 这个 scope
    Taro.chooseLocation({
      success (res) {
        setUserInfo(res)
      },
      fail (res) {
        console.log(res)
      }
    })
  }
  // 跳转到门店详情
  jumpDetail = () => {
    Taro.navigateTo({
      url: '/pages/storeDetail/index'
    })
  }
  //滚动页面触发
  onScroll = (e) => {
    if (e.currentTarget.scrollTop > 275) {
      this.setState({
        showSearch: true,
        pageName: '搜索门店',
      })
    } else {
      this.setState({
        showSearch: false,
        pageName: '首页',
      })
    }
  }
  // 领券
  getCoupon = () => {
    Taro.showToast({
      title: '领券成功-请到「我的券包」中查看',
      icon: 'none',
    })
  }
  // 点击完成进行跳转
  onConfirm = (e) => {
    console.log(e.detail.value)
    Taro.navigateTo({
      url: `/pages/storeList/index?value=${e.detail.value}`
    })
  }
  render () {
    const {nav} = this.props
    const titleTop = (nav.globalData.navHeight - nav.globalData.navTop - 24) / 2 + nav.globalData.navTop
    const user = this.props.user;
    // console.log('user', user)
    return (
      <View className='index'>
        <NavBar pageName={this.state.pageName} bgColor='#fff'>
          <View
            style={`left:${nav.globalData.navRight}px;top:${titleTop}px;background-color:rgba(255,255,255,.6)`}
            className='city'
            onClick={this.selectCity}
          >
            <Image className='loc-icon' src='http://hh-oss-picture.miyapay.com/box/ecc4010b31ff54e6b7ed7e39da037617.png' />
          </View>
        </NavBar>
        <ScrollView
          style={`height: ${nav.globalData.screenHeight - 300}px`}
          className='scrollview'
          scrollY
          onScroll={this.onScroll}
        >
        <Swiper
          className='swpier-view'
          indicatorColor='rgba(255,255,255,.4)'
          indicatorActiveColor='#fff'
          circular
          indicatorDots
          autoplay
        >
          {
            this.state.banner.map((item, index) => {
              return <SwiperItem key={index}>
                  <Image className='img' src={item.url} />
                </SwiperItem>
            })
          }
        </Swiper>
        <View className='sub-nav'>
          <View className='content'>
            <Image className='img' src='http://hh-oss-picture.miyapay.com/box/67bb9181c2ff1eb0ece1fd78511e2513.png' />
            <Text className='text'>领券中心</Text>
          </View>
          <View className='content'>
            <Image className='img' src='http://hh-oss-picture.miyapay.com/box/cc0a2da65a59f3bc91980534a142ae16.png' />
            <Text className='text'>我的券包</Text>
          </View>
        </View>
        <View className='sub-title'>
          <Text className='text'>领券中心</Text>
        </View>
        <ScrollView
          className='scrollx-view'
          scrollX
        >
          {
            this.state.scrollxData.map(item => {
              return <View className='coupon-view' key={item.url}>
                <View className='coupon-info'>
                  <Text className={item.type === 2 ? 'coupon-type-all' : 'coupon-type-single'}>{item.type === 1 ? '单品' : '全场'}</Text>
                  <View className='coupon-info-img'>
                    <Image className='img' src={item.url}></Image>
                  </View>
                  <View className='coupon-info-text'>
                    <Text className='name'>{item.name}</Text>
                    <Text className='time'>{item.time}</Text>
                  </View>
                </View>
                <LoginAuth className='coupon-btn' onSuccess={this.getCoupon}>
                  <View className='text'>领取</View>
                </LoginAuth>
              </View>
            })
          }
          <View className='more'>
            <Text className='text'>查看更多</Text>
          </View>
        </ScrollView>
        <View className='sub-title' id='store'>
          <Text className='text'>附近门店</Text>
        </View>
        <View>
          {
            this.state.storeList.map((item, index) => {
              return <View key={index} className='list-view' onClick={this.jumpDetail}>
              <Image className='img' src={item.img} />
              <View className='text-cont'>
                <Text className='name'>{item.name}</Text>
                <Text className='time'>{item.time}</Text>
              </View>
              <View className='distance'>
                <Image className='img' src='http://hh-oss-picture.miyapay.com/box/e43fc1fd3ec446d985fef922388b4e00.png'></Image>
                <Text className='text'>{item.distance}</Text>
              </View>
            </View>
            })
          }
        </View>
        </ScrollView>
        {
          this.state.showSearch && <View className='search' style={`top:${nav.globalData.navHeight}px`}>
            <Icon className='icon' size='20' type='search' />
            <Input onConfirm={this.onConfirm} placeholderClass='placeholder' className='input' confirmType='search' type='text' placeholder='搜索门店' />
          </View>
        }
      </View>
    )
  }
}

export default Index
